const fs = require('fs');
const path = require('path');

const Controller = require('egg').Controller;

class UploadController extends Controller {
  async index() {
    const { ctx } = this;
    const file = ctx.request.files[0];
    const fileinfo = fs.readFileSync(file.filepath);
    const arr = file.filename.split('.');
    const filename = arr[0] + new Date().getTime() + '.' + arr[arr.length - 1];
    const target = path.join('app/public/uploads', filename);
    try {
      await fs.writeFileSync(target, fileinfo);
    } catch (error) {
      throw error;
    } finally {
      await fs.promises.unlink(file.filepath, err => {
        if (err) {
          throw err;
        }
      });
    }
    ctx.body = {
      url: 'http://' + ctx.host + `/public/uploads/${filename}`,
    };
  }
}

module.exports = UploadController;
